<template>
  <div>
    <codemirror
      v-model="code"
      placeholder="¡Escribe el código aquí!"
      :style="{ height: '600px' }"
      :autofocus="true"
      :indent-with-tab="true"
      :tab-size="2"
      :extensions="extensions"
      @ready="handleReady"
      @change="log('change', code)"
      @focus="log('focus', $event)"
      @blur="log('blur', $event)"
    ></codemirror>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted, nextTick, watch } from "vue";
import { shallowRef } from "vue";
import { Codemirror } from "vue-codemirror";
import { oneDark } from "@codemirror/theme-one-dark";
import { StreamLanguage } from "@codemirror/language";
import { lua } from "@codemirror/legacy-modes/mode/lua";
import { javascript } from "@codemirror/lang-javascript";

export default defineComponent({
  components: {
    Codemirror,
  },
  props: ["positionBufferCodemirror", "catalejoDataPrj", "magicCode"],
  emits: ["loadRefCodeFromCodemirror"],
  setup(props, context) {
    // const code = ref(`console.log("Hello, world!")`);
    // const code = ref(`print("hello")`);
    const code = ref("");
    // let extensions = [javascript(), oneDark];
    const extensions = ref();

    // Codemirror EditorView instance ref
    const view = shallowRef();
    const handleReady = (payload) => {
      view.value = payload.view;
    };

    // Status is available at all times via Codemirror EditorView
   /* const getCodemirrorStates = () => {
      const state = view.value.state;
      const ranges = state.selection.ranges;
      const selected = ranges.reduce((r, range) => r + range.to - range.from, 0);
      const cursor = ranges[0].anchor;
      const length = state.doc.length;
      const lines = state.doc.lines;
      // more state info ...
      // return ...
    };*/

    const pasteCodeInCodeMirror = (codeToInsert) => {
      view.value.dispatch({
        changes: {
          from: 0,
          to: view.value.state.doc.length,
          insert: codeToInsert,
        },
      });
    };

    const pasteCodeInCursorPosition = (codeToInsert) => {
      const cursor = view.value.state.selection.main.head;
      view.value.dispatch({
        changes: {
          from: cursor,
          to: cursor,
          insert: codeToInsert,
        },
        selection: { anchor: cursor + 1 },
      });
    };

    const getCodeFromCodeMirror = () => {
      return view.value.state.doc.toString();
    };

    onMounted(async () => {
      context.emit("loadRefCodeFromCodemirror", code);
    });

    watch(
      () => props.catalejoDataPrj,
      (catalejoDataPrj) => {
        // TODO: cambiar nombres de chuck o luna8266 por una estructura
        if (catalejoDataPrj.TYPE_PRJ == "chuck") {
          extensions.value = [javascript(), oneDark];
        } else if (catalejoDataPrj.TYPE_PRJ == "luna8266") {
          extensions.value = [StreamLanguage.define(lua), oneDark];
        }
      },
    );

    watch(
      () => props.positionBufferCodemirror,
      async (newPositionBufferCodemirror) => {
        pasteCodeInCodeMirror(
          await props.catalejoDataPrj.getMirrorCode(
            newPositionBufferCodemirror,
          ),
        );
      },
    );

    watch(
      () => props.magicCode,
      (newMagicCode) => {
        pasteCodeInCursorPosition(newMagicCode.code);
      },
    );

    return {
      code,
      extensions,
      handleReady,
      log: console.log,
      pasteCodeInCursorPosition,
      getCodeFromCodeMirror,
    };
  },
});
</script>
